package no.ntnu.idatt1002.demo.controller;

import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Node;
import javafx.scene.Parent;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.ButtonType;
import javafx.scene.control.Dialog;
import javafx.scene.control.DialogPane;
import javafx.stage.Stage;
import no.ntnu.idatt1002.demo.data.Economics.Expense;
import no.ntnu.idatt1002.demo.data.Economics.FileHandling;
import no.ntnu.idatt1002.demo.data.Economics.Income;
import no.ntnu.idatt1002.demo.data.Economics.IncomeRegister;
import no.ntnu.idatt1002.demo.data.recipes.*;

import java.io.IOException;
import java.net.URL;
import java.util.Optional;
import java.util.ResourceBundle;

public class SuggestRecipesController implements Initializable {

    IngredientsAtHand ingredientsAtHand;
    RecipeRegister recipeRegister;


    @FXML
    private Button addToFridgeBtn;

    @FXML
    private Button goBackBtn;

    private ObservableList<FoodItem> fridge;

    private ObservableList<Recipe> recipes;


    @FXML
    private void addIngredient(ActionEvent event) throws IOException {
        FXMLLoader loader = new FXMLLoader();
        System.out.println("Time to pop up the pop-up!");
        loader.setLocation(getClass().getResource("/view/AddIngredient.fxml"));
        DialogPane addIngredientPane = loader.load();

        AddIngredientController addIngredientController = loader.getController();

        Dialog<ButtonType> dialog = new Dialog<>();
        dialog.setDialogPane(addIngredientPane);
        dialog.setTitle("Add ingredient to fridge");

        Optional<ButtonType> clickedButton = dialog.showAndWait();
        if (clickedButton.get() == ButtonType.OK) {
            System.out.println("Clickecked OK!");
        }else if(clickedButton.get() == ButtonType.CANCEL) {
            System.out.println("Close the dialog");
        }


    }

    @FXML
    private void goBack(ActionEvent event) throws IOException {
        FXMLLoader loader = new FXMLLoader();

        System.out.printf("Back button pressed");
        loader.setLocation(getClass().getResource("/view/MainMenuNew.fxml"));

        Parent root = loader.load();
        Stage stage = (Stage) ((Node) event.getSource()).getScene().getWindow();
        Scene scene = new Scene(root);
        stage.setScene(scene);
        stage.show();

    }


    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {

         ingredientsAtHand = FileHandler.readIngredientsAtHand("Fridge");
         fridge = FXCollections.observableArrayList(ingredientsAtHand.getIngredientsAtHand());

         recipeRegister = FileHandler.readRecipeRegister("Recipes");
         recipes = FXCollections.observableArrayList(recipeRegister.getRecipes());

    }
}
